﻿function LockNotes_SlashCommandHandler( msg )
    LockNotes_Frame1:Show();
    nightfallCheckbox:SetChecked(nightfallEnabled);
    buffsCheckbox:SetChecked(enemyBuffsEnabled);
    targetOnlyCheckbox:SetChecked(targetAndFocusOnly);
    targetChangeUpdateCheckbox:SetChecked(targetChangeUpdate);
    if (targetOnlyCheckbox:GetChecked()) then
        targetChangeUpdateCheckbox:Enable();
    else
        targetChangeUpdateCheckbox:Disable();
    end
    missesCheckbox:SetChecked(resistsEnabled);
    meleeNoisesCheckBox:SetChecked(meleeNoisesEnabled);
    LockNotes_FearCOTDownCheckbox:SetChecked(LockNotes_FearCOTDown);
    if (buffsCheckbox:GetChecked()) then
        targetOnlyCheckbox:Enable();
    else
        targetOnlyCheckbox:Disable();
    end
    LockNotes_DispelCheckbox:SetChecked(LNDispelTable["DispelEnabled"]);
    LockNotes_DispelCheckbox_OnClick();
    LockNotes_DispelVisualAlertCheckbox:SetChecked(LNDispelTable["DispelVisualAlert"]);
    LockNotes_DispelChatlogCheckbox:SetChecked(LNDispelTable["DispelChatlog"]);
    LockNotes_DispelSayCheckbox:SetChecked(LNDispelTable["DispelSay"]);
    LockNotes_DispelPartyCheckbox:SetChecked(LNDispelTable["DispelParty"]);
    LockNotes_DispelRaidCheckBox:SetChecked(LNDispelTable["DispelRaid"]);
    LockNotes_DispelBattlegroundCheckbox:SetChecked(LNDispelTable["DispelBattleground"]);
    LockNotes_SpelllockCheckbox:SetChecked(LNSpelllockTable["SpelllockEnabled"]);
    LockNotes_SpelllockCheckbox_OnClick();
    LockNotes_SpelllockVisualAlertCheckbox:SetChecked(LNSpelllockTable["SpelllockVisualAlert"]);
    LockNotes_SpelllockChatlogCheckbox:SetChecked(LNSpelllockTable["SpelllockChatlog"]);
    LockNotes_SpelllockSayCheckbox:SetChecked(LNSpelllockTable["SpelllockSay"]);
    LockNotes_SpelllockPartyCheckbox:SetChecked(LNSpelllockTable["SpelllockParty"]);
    LockNotes_SpelllockRaidCheckBox:SetChecked(LNSpelllockTable["SpelllockRaid"]);
    LockNotes_SpelllockBattlegroundCheckbox:SetChecked(LNSpelllockTable["SpelllockBattleground"]);
    LockNotes_IconsCheckBox:SetChecked(LockNotes_Icons);
    LockNotes_TremorTotemCheckBox:SetChecked(LockNotes_TremorTotem);
    LockNotes_DeathAnnounceCheckBox:SetChecked(LockNotes_DeathAnnounce);
    LockNotes_DeathAnnounceSoundsCheckBox:SetChecked(LockNotes_DeathAnnounceSounds);
	PlaySound("igMainMenuOpen");
end
----------------------------------------------------------------Button Functions----------------------------------------------------------------
function LockNotes_cancelButton_OnClick()   --------CANCEL BUTTON
    LockNotes_Frame1:Hide();
    PlaySound("igMainMenuClose");
end

function LockNotes_FrameReset_OnClick()
    LockNotes_TremorTotemFrame:SetAlpha(0);
    LockNotes_TremorTotemFrame:EnableMouse(false);
    LockNotes_TremorTotemFrame:UnregisterAllEvents();
    LockNotes_TremorTotemFrame:SetUserPlaced(false);
    LockNotes_TremorTotemFrame:SetMovable(false);

    LockNotes_DispelSpellLockFrame:SetAlpha(0);
    LockNotes_DispelSpellLockFrame:EnableMouse(false);
    LockNotes_DispelSpellLockFrame:UnregisterAllEvents();
    LockNotes_DispelSpellLockFrame:SetUserPlaced(false);
    LockNotes_DispelSpellLockFrame:SetMovable(false);

    LockNotes_MainDisplayFrame:SetAlpha(0);
    LockNotes_MainDisplayFrame:EnableMouse(false);
    LockNotes_MainDisplayFrame:UnregisterAllEvents();
    LockNotes_MainDisplayFrame:SetUserPlaced(false);
    LockNotes_MainDisplayFrame:SetMovable(false);

    LockNotes_FearSeduceFrame:SetAlpha(0);
    LockNotes_FearSeduceFrame:EnableMouse(false);
    LockNotes_FearSeduceFrame:UnregisterAllEvents();
    LockNotes_FearSeduceFrame:SetUserPlaced(false);
    LockNotes_FearSeduceFrame:SetMovable(false);

    LockNotes_MovingFrame:Hide();
    ReloadUI();
end

function LockNotes_FrameSet_OnClick()
    LockNotes_TremorTotemFrame:SetAlpha(0);
    LockNotes_TremorTotemFrame:EnableMouse(false);
    LockNotes_TremorTotemFrame:UnregisterAllEvents();

    LockNotes_DispelSpellLockFrame:SetAlpha(0);
    LockNotes_DispelSpellLockFrame:EnableMouse(false);
    LockNotes_DispelSpellLockFrame:UnregisterAllEvents();

    LockNotes_MainDisplayFrame:SetAlpha(0);
    LockNotes_MainDisplayFrame:EnableMouse(false);
    LockNotes_MainDisplayFrame:UnregisterAllEvents();

    LockNotes_FearSeduceFrame:SetAlpha(0);
    LockNotes_FearSeduceFrame:EnableMouse(false);
    LockNotes_FearSeduceFrame:UnregisterAllEvents();

    LockNotes_MovingFrame:Hide();
    PlaySound("igMainMenuClose");
end

function LockNotes_MoveFramesButton_OnClick()
    LockNotes_Frame1:Hide();

    LockNotes_TremorTotemFrame:SetMovable(true);
    LockNotes_TremorTotemFrame:SetAlpha(1);
    LockNotes_TremorTotemFrame:SetUserPlaced(true);
    LockNotes_TremorTotemFrame:EnableMouse(true);
    LockNotes_TremorTotemFrame:RegisterForDrag("LeftButton");
    LockNotes_TremorTotemFrame:SetScript("OnDragStart",LockNotes_TremorTotemFrame.StartMoving);
    LockNotes_TremorTotemFrame:SetScript("OnDragStop",LockNotes_TremorTotemFrame.StopMovingOrSizing);

    LockNotes_DispelSpellLockFrame:SetMovable(true);
    LockNotes_DispelSpellLockFrame:SetAlpha(1);
    LockNotes_DispelSpellLockFrame:SetUserPlaced(true);
    LockNotes_DispelSpellLockFrame:EnableMouse(true);
    LockNotes_DispelSpellLockFrame:RegisterForDrag("LeftButton");
    LockNotes_DispelSpellLockFrame:SetScript("OnDragStart",LockNotes_DispelSpellLockFrame.StartMoving);
    LockNotes_DispelSpellLockFrame:SetScript("OnDragStop",LockNotes_DispelSpellLockFrame.StopMovingOrSizing);

    LockNotes_MainDisplayFrame:SetMovable(true);
    LockNotes_MainDisplayFrame:SetAlpha(1);
    LockNotes_MainDisplayFrame:SetUserPlaced(true);
    LockNotes_MainDisplayFrame:EnableMouse(true);
    LockNotes_MainDisplayFrame:RegisterForDrag("LeftButton");
    LockNotes_MainDisplayFrame:SetScript("OnDragStart",LockNotes_MainDisplayFrame.StartMoving);
    LockNotes_MainDisplayFrame:SetScript("OnDragStop",LockNotes_MainDisplayFrame.StopMovingOrSizing);

    LockNotes_FearSeduceFrame:SetMovable(true);
    LockNotes_FearSeduceFrame:SetAlpha(1);
    LockNotes_FearSeduceFrame:SetUserPlaced(true);
    LockNotes_FearSeduceFrame:EnableMouse(true);
    LockNotes_FearSeduceFrame:RegisterForDrag("LeftButton");
    LockNotes_FearSeduceFrame:SetScript("OnDragStart",LockNotes_FearSeduceFrame.StartMoving);
    LockNotes_FearSeduceFrame:SetScript("OnDragStop",LockNotes_FearSeduceFrame.StopMovingOrSizing);

    LockNotes_MovingFrame:Show();
    PlaySound("igMainMenuOption");
end
local immuneSpells = {};
local ignoreMissSpells = {};
function setAlertSpells()
	-----------------------------------------------------------Spells to watch for and alert--------------------------------------------
local playerClass = select(2, UnitClass("player"));
if(playerClass ~= "WARLOCK") then
	LockNotes_SoulLinkAlert = false;
	nightfallEnabled = false;
	eradicationEnabled = false;
	LockNotes_DrainSoul = false;
end
if(playerClass == "WARLOCK" or playerClass == "PRIEST") then
	immuneSpells = {--[80215] = true,
					[31224] = true, -- Cloak of Shadows
					[46924] = true, -- Bladestorm
					[642] = true,   -- Divine Shield
					[47585] = true, -- Disperson
					[23920] = true, -- Spell Reflect
					[114028] = true, --Mass Spell Reflect
					[48707] = true, -- Anti Magic Shell
					[45438] = true, -- IceBlock
					[19263] = true, -- Deterrence
					[49039] = true, -- LichBorne
					[18499] = true, -- Berserker Rage
 					[6346] = true,  -- Fear Ward
					[1719] = true,  -- Recklessness
					[96267] = true,  -- Strength of Soul
					[8178] = true, -- Grounding Totem
					[131558] = true, --Spiritwalker's Aegis
					[104773] = true, --Unending Resolve
					[124488] = true, --Zen Focus
					[31821] = true}; -- Concentration Aura
elseif(playerClass == "WARRIOR") then
immuneSpells = {--[80215] = true,
					[46924] = true, -- Bladestorm
					[642] = true,   -- Divine Shield
					[47585] = true, -- Disperson
					[45438] = true, -- IceBlock
					[19263] = true, -- Deterrence
					[49039] = true, -- LichBorne
					[18499] = true, -- Berserker Rage
 					[6346] = true,  -- Fear Ward
					[1719] = true,  -- Recklessness
					[96267] = true,  -- Strength of Soul
					[131558] = true, --Spiritwalker's Aegis
					[104773] = true, --Unending Resolve
					[124488] = true, --Zen Focus
					[54216] = true, -- Master's Call
					[31821] = true}; -- Concentration Aura
elseif(playerClass == "MAGE" or playerClass == "DRUID" or playerClass == "SHAMAN" or playerClass == "PALADIN" or playerClass == "MONK") then
	immuneSpells = {[31224] = true, -- Cloak of Shadows
					[46924] = true, -- Bladestorm
					[642] = true,   -- Divine Shield
					[47585] = true, -- Disperson
					[23920] = true, -- Spell Reflect
					[114028] = true, --Mass Spell Reflect
					[48707] = true, -- Anti Magic Shell
					[45438] = true, -- IceBlock
					[19263] = true, -- Deterrence
					[96267] = true,  -- Strength of Soul
					[131558] = true, --Spiritwalker's Aegis
					[104773] = true, --Unending Resolve
					[124488] = true, --Zen Focus
					[8178] = true, -- Grounding Totem
					[31821] = true, -- Concentration Aura
					[1044] = true, -- Hand of Freedom
					[54216] = true}; -- Master's Call
elseif(playerClass == "ROGUE" or playerClass == "DEATHKNIGHT" or playerClass == "HUNTER") then
	immuneSpells = {--[80215] = true,
					[31224] = true, -- Cloak of Shadows
					[46924] = true, -- Bladestorm
					[642] = true,   -- Divine Shield
					[47585] = true, -- Disperson
					[48707] = true, -- Anti Magic Shell
					[45438] = true, -- IceBlock
					[19263] = true, -- Deterrence
					[96267] = true,  -- Strength of Soul
					[131558] = true, --Spiritwalker's Aegis
					[104773] = true, --Unending Resolve
					[124488] = true, --Zen Focus
					[8178] = true, -- Grounding Totem
					[31821] = true, -- Concentration Aura
					[1044] = true, -- Hand of Freedom
					[54216] = true}; -- Master's Call
end

if(playerClass == "WARLOCK") then
	ignoreMissSpells = {
						[1122] = true, --infernal
						[27243] = true, --seed of corruption
						[32865] = true, -- possible seed of corruption
						[103967] = true, -- Carrion Swarm
						[80240] = true, -- Havoc
						[5484] = true, -- Howl of Terror
						[30283] = true, -- Shadowfury
						[1949] = true, -- Hellfire
						[5730] = true, -- rain of fire
						[108685] = true, -- Fire and Brim Conflag
						[114654] = true, -- Fire and Brim Incinerate
						[108686] = true, -- Fire and Brim Immolate
						[104233] = true -- green rain of fire
						}
elseif(playerClass == "DEATHKNIGHT") then
	ignoreMissSpells = {
						[108199] = true, --gorefiends grasp
						[108200] = true, --remoreseless winter
						[43265] = true, --death and decay
						[115989] = true, --unholy blight
						[48721] = true, --Blood boil
						[50842] = true, -- pestilence
						[49184] = true --howling blast
						}
elseif(playerClass == "DRUID") then
	ignoreMissSpells = {
						[48505] = true, --starfall
						[99] = true, --disorienting roar
						[102359] = true, --mass entanglement
						[132469] = true, --typhoon
						[106996] = true, --astral storm
						[16914] = true, --hurricane
						[78675] = true --solar beam
						}
elseif(playerClass == "HUNTER") then
	ignoreMissSpells = {
						[13813] = true, --Explosive trap
						[13809] = true, --Ice trap
						[34600] = true --snake trap
						}
elseif(playerClass == "MAGE") then
	ignoreMissSpells = {
						[31661] = true, --Dragon's Breath
						[84714] = true, --Frozen Orb
						[113724] = true, --Ring of Frost
						[2120] = true, --flamestrike
						[122] = true, --Frost Nova
						[1449] = true --Arcane Explosion
						}
elseif(playerClass == "MONK") then
	ignoreMissSpells = {
						[115008] = true, --Chi Torpedo
						[116847] = true, --Rushing Jade Wind
						[119381] = true, --Leg Sweep
						[116844] = true, --Ring of peace
						[101546] = true --spinning crane kick
						}
elseif(playerClass == "PALADIN") then
	ignoreMissSpells = {
						[114165] = true, --Holy Prism
						[115750] = true, --Blinding light
						[53385] = true, --Divine Storm
						[53595] = true --Hammer of the Righteous
						}
elseif(playerClass == "PRIEST") then
	ignoreMissSpells = {
						[121135] = true, --Cascade
						[110744] = true, --Divine Star
						[120517] = true, --Halo
						[48045] = true, --Mind Sear
						[32375] = true, --Mass Dispel
						[108920] = true, --Void Tendrils
						[8122] = true --Psychic Scream
						}
elseif(playerClass == "ROGUE") then
	ignoreMissSpells = {
						[51723] = true, --Fan of knives
						[121411] = true --Crimson Tempest
						}
elseif(playerClass == "SHAMAN") then
	ignoreMissSpells = {
						[61882] = true, --Earthquake
						[1535] = true, --Fire Nova
						[51490] = true --thunderstorm
						}
elseif(playerClass == "WARRIOR") then
	ignoreMissSpells = {
						[46924] = true, --Bladestorm
						[118000] = true, --Dragon Roar
						[46968] = true, --Shockwave
						[1160] = true, --demoralizing shout
						[5246] = true, --Intimidating Shout
						[102060] = true, --Disrupting shout
						[12323] = true, --Piercing howl
						[107566] = true, --Staggering Shout
						[1680] = true, --Whirlwind
						[6343] = true, --Thunder Clap
						[6544] = true, --Heroic Leap
						}
 end
end

function LockNotes_okButton_OnClick()   -------OK BUTTON
------------------------------------------------------check if checkboxes checked---------------------------
	if(nightfallCheckbox:GetChecked()) then
        nightfallEnabled = true;
    else
		nightfallEnabled = false;
	end
	if(buffsCheckbox:GetChecked()) then
        enemyBuffsEnabled = true;
		if(targetOnlyCheckbox:GetChecked()) then
			targetAndFocusOnly = true;
		else
			targetAndFocusOnly = false;
		end
    else
		enemyBuffsEnabled = false;
		targetAndFocusOnly = false;
	end
	if(targetChangeUpdateCheckbox:GetChecked() and targetAndFocusOnly) then
        targetChangeUpdate = true;
    else
		targetChangeUpdate = false;
	end
    if(missesCheckbox:GetChecked()) then
		resistsEnabled = true;
    else
		resistsEnabled = false;
	end
	if(meleeNoisesCheckBox:GetChecked()) then
		meleeNoisesEnabled = true;
    else
		meleeNoisesEnabled = false;
	end
	if(LockNotes_DispelCheckbox:GetChecked()) then
        LNDispelTable["DispelEnabled"] = true;
    else
        LNDispelTable["DispelEnabled"] = false;
    end
    if(LNDispelTable["DispelEnabled"]) then
        if(LockNotes_DispelVisualAlertCheckbox:GetChecked()) then
            LNDispelTable["DispelVisualAlert"] = true;
        else
            LNDispelTable["DispelVisualAlert"] = false;
        end
        if(LockNotes_DispelChatlogCheckbox:GetChecked()) then
            LNDispelTable["DispelChatlog"] = true;
        else
            LNDispelTable["DispelChatlog"] = false;
        end
        if(LockNotes_DispelSayCheckbox:GetChecked()) then
            LNDispelTable["DispelSay"] = true;
        else
            LNDispelTable["DispelSay"] = false;
        end
        if(LockNotes_DispelPartyCheckbox:GetChecked()) then
            LNDispelTable["DispelParty"] = true;
        else
            LNDispelTable["DispelParty"] = false;
        end
        if(LockNotes_DispelRaidCheckBox:GetChecked()) then
            LNDispelTable["DispelRaid"] = true;
        else
            LNDispelTable["DispelRaid"] = false;
        end
        if(LockNotes_DispelBattlegroundCheckbox:GetChecked()) then
            LNDispelTable["DispelBattleground"] = true;
        else
            LNDispelTable["DispelBattleground"] = false;
        end
    else
        LNDispelTable["DispelVisualAlert"] = false;
        LNDispelTable["DispelChatlog"] = false;
        LNDispelTable["DispelSay"] = false;
        LNDispelTable["DispelParty"] = false;
        LNDispelTable["DispelRaid"] = false;
        LNDispelTable["DispelBattleground"] = false;
    end

    if(LockNotes_SpelllockCheckbox:GetChecked()) then
        LNSpelllockTable["SpelllockEnabled"] = true;
    else
        LNSpelllockTable["SpelllockEnabled"] = false;
    end
    if(LNSpelllockTable["SpelllockEnabled"]) then
        if(LockNotes_SpelllockVisualAlertCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockVisualAlert"] = true;
        else
            LNSpelllockTable["SpelllockVisualAlert"] = false;
        end
        if(LockNotes_SpelllockChatlogCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockChatlog"] = true;
        else
            LNSpelllockTable["SpelllockChatlog"] = false;
        end
        if(LockNotes_SpelllockSayCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockSay"] = true;
        else
            LNSpelllockTable["SpelllockSay"] = false;
        end
        if(LockNotes_SpelllockPartyCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockParty"] = true;
        else
            LNSpelllockTable["SpelllockParty"] = false;
        end
        if(LockNotes_SpelllockRaidCheckBox:GetChecked()) then
            LNSpelllockTable["SpelllockRaid"] = true;
        else
            LNSpelllockTable["SpelllockRaid"] = false;
        end
        if(LockNotes_SpelllockBattlegroundCheckbox:GetChecked()) then
            LNSpelllockTable["SpelllockBattleground"] = true;
        else
            LNSpelllockTable["SpelllockBattleground"] = false;
        end
    else
        LNSpelllockTable["SpelllockVisualAlert"] = false;
        LNSpelllockTable["SpelllockChatlog"] = false;
        LNSpelllockTable["SpelllockSay"] = false;
        LNSpelllockTable["SpelllockParty"] = false;
        LNSpelllockTable["SpelllockRaid"] = false;
        LNSpelllockTable["SpelllockBattleground"] = false;
    end

    if(LockNotes_FearCOTDownCheckbox:GetChecked()) then
        LockNotes_FearCOTDown = true;
    else
        LockNotes_FearCOTDown = false;
    end
    if(LockNotes_IconsCheckBox:GetChecked()) then
        LockNotes_Icons = true;
    else
        LockNotes_Icons = false;
    end
    if(LockNotes_TremorTotemCheckBox:GetChecked()) then
        LockNotes_TremorTotem = true;
    else
        LockNotes_TremorTotem = false;
    end
    if(LockNotes_DeathAnnounceCheckBox:GetChecked()) then
        LockNotes_DeathAnnounce = true;
		if(LockNotes_DeathAnnounceSoundsCheckBox:GetChecked() and LockNotes_DeathAnnounceSoundsCheckBox:IsEnabled())then
			LockNotes_DeathAnnounceSounds = true;
		else
			LockNotes_DeathAnnounceSounds = false;
		end
    else
        LockNotes_DeathAnnounce = false;
		LockNotes_DeathAnnounceSounds = false;
    end
	LockNotes_Frame1:Hide();
    if(not targetChangeUpdate) then
        LockNotesFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
        LockNotesFrame:UnregisterEvent("PLAYER_FOCUS_CHANGED");
    else
        LockNotesFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
        LockNotesFrame:RegisterEvent("PLAYER_FOCUS_CHANGED");
    end
    if(LockNotes_Icons) then
        LockNotes_MainDisplayFrameTexture:Show();
        LockNotes_DispelSpellLockFrameTexture:Show();
    else
        LockNotes_MainDisplayFrameTexture:Hide();
        LockNotes_DispelSpellLockFrameTexture:Hide();
    end
	modifyEventRegistered("LockNotes");
    PlaySound("igMainMenuClose");
end
-----------------------------------------------------------------------------CheckBox Clicks-------------------------------------------------------------
function targetOnlyCheckbox_OnClick()  ------TARGETONLYCHECKBOX CLICK
    if(targetOnlyCheckbox:GetChecked() and targetOnlyCheckbox:IsEnabled()) then
        targetChangeUpdateCheckbox:Enable();
    else
        targetChangeUpdateCheckbox:Disable();
    end
end

function LockNotes_DeathAnnounceCheckBox_OnClick()
    if(LockNotes_DeathAnnounceCheckBox:GetChecked())then
        LockNotes_DeathAnnounceSoundsCheckBox:Enable();
    else
        LockNotes_DeathAnnounceSoundsCheckBox:Disable();
    end
end

function buffsCheckbox_OnClick()     -------BUFFS CHECKBOX CLICK
    if (buffsCheckbox:GetChecked()) then -- disable target/focus only checkbox if buffs are turned off
        targetOnlyCheckbox:Enable();
		if(targetOnlyCheckbox:GetChecked()) then
			targetChangeUpdateCheckbox:Enable();
		end
    else
        targetOnlyCheckbox:Disable();
        targetChangeUpdateCheckbox:Disable();
    end
end

function LockNotes_DispelCheckbox_OnClick()
    if(LockNotes_DispelCheckbox:GetChecked()) then
        LockNotes_DispelVisualAlertCheckbox:Enable();
        LockNotes_DispelChatlogCheckbox:Enable();
        LockNotes_DispelSayCheckbox:Enable();
        LockNotes_DispelPartyCheckbox:Enable();
        LockNotes_DispelRaidCheckBox:Enable();
        LockNotes_DispelBattlegroundCheckbox:Enable();     
    else
        LockNotes_DispelVisualAlertCheckbox:Disable();
        LockNotes_DispelChatlogCheckbox:Disable();
        LockNotes_DispelSayCheckbox:Disable();
        LockNotes_DispelPartyCheckbox:Disable();
        LockNotes_DispelRaidCheckBox:Disable();
        LockNotes_DispelBattlegroundCheckbox:Disable();
    end
end

function LockNotes_SpelllockCheckbox_OnClick()
    if(LockNotes_SpelllockCheckbox:GetChecked()) then
        LockNotes_SpelllockVisualAlertCheckbox:Enable();
        LockNotes_SpelllockChatlogCheckbox:Enable();
        LockNotes_SpelllockSayCheckbox:Enable();
        LockNotes_SpelllockPartyCheckbox:Enable();
        LockNotes_SpelllockRaidCheckBox:Enable();
        LockNotes_SpelllockBattlegroundCheckbox:Enable();     
    else
        LockNotes_SpelllockVisualAlertCheckbox:Disable();
        LockNotes_SpelllockChatlogCheckbox:Disable();
        LockNotes_SpelllockSayCheckbox:Disable();
        LockNotes_SpelllockPartyCheckbox:Disable();
        LockNotes_SpelllockRaidCheckBox:Disable();
        LockNotes_SpelllockBattlegroundCheckbox:Disable();
    end
end
----------------------------------------------------------------On Load-------------------------------------------------------------------------
function LockNotes_OnLoad(this)
    this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    this:RegisterEvent("PLAYER_TARGET_CHANGED");
    this:RegisterEvent("PLAYER_FOCUS_CHANGED");
    this:RegisterEvent("ADDON_LOADED");
    MySpellReflected = 1;
    LockNotes_TremorTotemID = 0;
    LNDispelTable={DispelEnabled = true, DispelVisualAlert = true, DispelChatlog = true, DispelSay = false, DispelParty = false, DispelRaid = false, DispelBattleground = false};
    LNSpelllockTable={SpelllockEnabled = true, SpelllockVisualAlert = true, SpelllockChatlog = true, SpelllockSay = false, SpelllockParty = false, SpelllockRaid = false, SpelllockBattleground = false};
------------------------------------initialize savedvariables on first startup
    nightfallEnabled=true;
    enemyBuffsEnabled=true;
    targetAndFocusOnly=true;
    targetChangeUpdate=true;
    resistsEnabled=true;
    meleeNoisesEnabled=true;
    eradicationEnabled=false;--removed
    LockNotes_ErrorFilter=false;--removed
    LockNotes_SoulLinkAlert=false;--removed
    LockNotes_FearCOTDown=true;
    LockNotes_Icons=true;
    LockNotes_TremorTotem=false;
    LockNotes_DeathAnnounce = false;
    LockNotes_DeathAnnounceSounds = false;
	LockNotes_DrainSoul = false; --removed
	---------------------------------end initialization of saved variables, begin slash commands
    SlashCmdList["LOCKNOTES"] = LockNotes_SlashCommandHandler; -- Add slash command handler to the list of slash commands
    SLASH_LOCKNOTES1 = "/locknotes"; -- Associate /locknotes with the slash command list entry for LOCKNOTES
    SLASH_LOCKNOTES2 = "/ln"; -- Associate /ln with the slash command list entry for LOCKNOTES
end

------------------------------------------------------------ Change main Frame-----------------------------------------------------
function LockNotes_ChangeMainFrame(mainText, color1, color2, color3, spellID)
	LockNotes_MainDisplayFrameFlasher:Stop()
	LockNotes_MainDisplayFrameFontString:SetText(mainText);
	LockNotes_MainDisplayFrameFontString:SetTextColor(color1, color2, color3);
	LockNotes_MainDisplayFrameTexture:SetTexture(GetSpellTexture(spellID));
	LockNotes_MainDisplayFrameFlasher:Play()
end

------------------------------------------------------------Target and focus change------------------------------------------------
function LockNotes_OnEventTargetChange()
    if (UnitIsEnemy("player","target")) then
        local i = 1;
        local buffNOTNil = true;
        while (i <=40 and buffNOTNil) do local spellID=select(11, UnitBuff("target",i));   
            i=i+1;
            buffNOTNil = spellID;
            if(immuneSpells[spellID]) then
                local spellName = select(1, GetSpellInfo(spellID));
                LockNotes_ChangeMainFrame(""..spellName.." up! (TAR)", 1, 0, 0, spellID);
                if (spellID == 96267) or (spellID == 31821) or (spellID == 131558) or (spellID == 104773) or (spellID == 124488) then -- Conc aura and inner focus, uninterruptable heals
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
			    elseif (spellID == 49039) or (spellID == 18499) or (spellID == 6346) or (spellID == 46924) then -- Lichborne, zerker rage, and fear ward, just unfearable
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
			    else
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
			    end
			    if (spellID == 23920) then
			        MySpellReflected = false;
			    end
            end    
        end
    end
end

function LockNotes_OnEventFocusChange()
    if (UnitIsEnemy("player","focus")) then
        local i = 1;
        local buffNOTNil = true;
        while (i <=40 and buffNOTNil) do local spellID=select(11, UnitBuff("focus",i));   
            i=i+1;
            buffNOTNil = spellID;
			if(immuneSpells[spellID]) then
                local spellName = select(1, GetSpellInfo(spellID));
                LockNotes_ChangeMainFrame(""..spellName.." up! (foc)", 1, 0, 1, spellID);
                if (spellID == 96267) or (spellID == 31821) or (spellID == 131558) or (spellID == 104773) or (spellID == 124488) then -- Conc aura and inner focus, uninterruptable heals
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
			    elseif (spellID == 49039) or (spellID == 18499) or (spellID == 6346) or (spellID == 46924) then -- Lichborne, zerker rage, and fear ward, just unfearable
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
			    else
				    PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
			    end
			    if (spellID == 23920) then
			        MySpellReflected = false;
			    end
            end    
        end
    end
end

function LockNotes_StripServer(text)
	local name, server = string.match(text, "(.-)%-(.*)$")
	if( not name and not server ) then
		return text
	end
	
	return name
end

function LockNotes_UnRegisterNonCheckedEvents(addonName)
	if(addonName == "LockNotes") then
		if(LockNotes_Icons) then
			LockNotes_DispelSpellLockFrameTexture:Show();
			LockNotes_MainDisplayFrameTexture:Show();
		else
			LockNotes_MainDisplayFrameTexture:Hide();
			LockNotes_DispelSpellLockFrameTexture:Hide();
		end
		if(not targetChangeUpdate) then
			LockNotesFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
			LockNotesFrame:UnregisterEvent("PLAYER_FOCUS_CHANGED");
		end
	end
end

function LockNotes_EventHandler(self, event, ...)
    if(event=="COMBAT_LOG_EVENT_UNFILTERED") then
        LockNotes_CombatLogEvent(self, event, ...);
    elseif(event=="PLAYER_TARGET_CHANGED") then
        LockNotes_OnEventTargetChange();
    elseif(event=="PLAYER_FOCUS_CHANGED") then
        LockNotes_OnEventFocusChange();
    elseif(event=="ADDON_LOADED") then
        LockNotes_UnRegisterNonCheckedEvents(...);
		modifyEventRegistered(...);
    end   
end

local eventRegistered = {};

function modifyEventRegistered(addonName)
if(addonName == "LockNotes") then
	setAlertSpells();
	eventRegistered = {["SPELL_SUMMON"] = true, ["UNIT_DESTROYED"] = true};
	if(nightfallEnabled) then
		eventRegistered["SPELL_AURA_APPLIED"] = true;
		eventRegistered["SPELL_AURA_REFRESH"] = true;
	end
	if(meleeNoisesEnabled or enemyBuffsEnabled) then
		eventRegistered["SPELL_CAST_SUCCESS"] = true;
	end
	if(LockNotes_FearCOTDown or enemyBuffsEnabled) then
		eventRegistered["SPELL_AURA_REMOVED"] = true;
	end
	if(LNDispelTable["DispelEnabled"]) then
		eventRegistered["SPELL_DISPEL"] = true;
		eventRegistered["SPELL_STOLEN"] = true;
		eventRegistered["SPELL_DISPEL_FAILED"] = true
	end
	if(LNSpelllockTable["SpelllockEnabled"]) then
		eventRegistered["SPELL_INTERRUPT"] = true;
	end
	if(resistsEnabled) then
		eventRegistered["SPELL_MISSED"] = true;
	end
	if(LockNotes_DeathAnnounce) then
		eventRegistered["UNIT_DIED"] = true;
	end
end
end

function LockNotes_CombatLogEvent(self, event, timeStamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, arg11, arg12, arg13)
if( not eventRegistered[eventType] ) then
    return
end
------------------------------------------------------------- Friendly Buffs --------------------------------
-- Shadow Trance/BackSlash
if (eventType == "SPELL_AURA_APPLIED" or eventType == "SPELL_AURA_REFRESH") then
	if bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then
        if (spellID == 17941) then  -- nightfall proc
			LockNotes_ChangeMainFrame("Gained Shard!", 1, 0, 1, spellID);
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\ding.ogg");
        elseif (spellID == 140076 or spellID == 34936) then  -- backlash proc
            LockNotes_ChangeMainFrame("Incinerate!", 1, 0.5, 0, spellID);
            PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\ding.ogg");
		end
    end            
------------------------------------------------------------- Hostile Spells --------------------------------
elseif (eventType == "SPELL_CAST_SUCCESS") then
	if (meleeNoisesEnabled and destName==UnitName("player") and
        ((spellID == 6552) -- Pummel
     or (spellID == 96231) --  Rebuke
     or (spellID == 1766) --  Kick
     or (spellID == 80964) --  Skull Bash Bear (might not be needed, it's pretty loud already, but just for consistancy)
     or (spellID == 80965) --  Skull Bash Cat
	 or (spellID == 57994) --  Wind Shear
	 or (spellID == 116705) --  Spear Hand Strike
     or (spellID == 47528))) then  --  Mind Freeze
		PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\gun_fire.ogg");
	elseif  bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 and enemyBuffsEnabled then -- Makes sure it's an enemy player    
		if(immuneSpells[spellID]) then
			local target = UnitGUID("target") -- aquire the player's target
			local focus = UnitGUID("focus")  -- aquire the player's focus
            if (sourceGUID==target or sourceGUID==focus) then  -- if source is either target or focus
			    if (sourceGUID==target) then  -- if source is target then...
    				LockNotes_ChangeMainFrame(""..spellName.." up! (TAR)", 1, 0, 0, spellID);
                    if (spellID == 96267) or (spellID == 31821) or (spellID == 131558) or (spellID == 104773) or (spellID == 124488) then -- Conc aura and inner focus, uninterruptable heals
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
					elseif (spellID == 49039) or (spellID == 18499) or (spellID == 6346) or (spellID == 46924) then -- Lichborne, zerker rage, and fear ward, just unfearable
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
					else
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
					end
					if (spellID == 23920) then
					MySpellReflected = false;
					end
				elseif(sourceGUID==focus) then -- if source isn't target but is focus then...
					LockNotes_ChangeMainFrame(""..spellName.." up! (foc)", 1, 0, 1, spellID);
					if (spellID == 96267) or (spellID == 31821) or (spellID == 131558) or (spellID == 104773) or (spellID == 124488) then -- Conc aura and inner focus, uninterruptable heals
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg");
					elseif (spellID == 49039) or (spellID == 18499) or (spellID == 6346) then -- Lichborne, zerker rage, and fear ward, just unfearable
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
					else
						PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
					end
					if (spellID == 23920) then
					MySpellReflected = false;					
					end
				end
			elseif(not targetAndFocusOnly) then  -- if target and focus only isn't checkmarked, ready the spam
				LockNotes_ChangeMainFrame(""..spellName.." up!", 1, 0, 0, spellID);
				if (spellID == 96267) or (spellID == 31821) or (spellID == 131558) or (spellID == 104773) or (spellID == 124488) then
					PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\bird_flap.ogg"); -- Conc aura and inner focus, uninterruptable heals
				elseif (spellID == 49039) or (spellID == 18499) or (spellID == 6346) then  -- Lichborne, zerker rage, and fear ward, just unfearable
					PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\buzz.ogg");			
				else
					PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\pulse.ogg"); -- for all pure magic immunities
				end
				if (spellID == 23920) then
				MySpellReflected = false;
				end				
			end
		end
	end

elseif (eventType == "SPELL_AURA_REMOVED") then
    if (LockNotes_FearCOTDown and (sourceGUID==UnitGUID("player") or sourceGUID==UnitGUID("pet")) and ((spellID==118699) or (spellID==6358) or (spellID==115268)or (spellID==2094) or (spellID==118))) then
        LockNotes_FearSeduceFrameFlasher:Stop();
		LockNotes_FearSeduceFrameFontString:SetText(spellName.." faded from "..LockNotes_StripServer(destName)..".");
        if(spellID==118699 or spellID==118) then
            LockNotes_FearSeduceFrameFontString:SetTextColor(.5, 0, .5);
        else
            LockNotes_FearSeduceFrameFontString:SetTextColor(1, 0.5, 1)
        end
        LockNotes_FearSeduceFrameFlasher:Play();
        PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\fearSeduceBreak.mp3");
	elseif (bit.band(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0  and enemyBuffsEnabled) then
        local target = UnitGUID("target")
		local focus = UnitGUID("focus")
		if(immuneSpells[spellID]) then
			if(target==sourceGUID) then
				LockNotes_ChangeMainFrame(""..spellName.." down.", 0, 1, 0, spellID);
			elseif(focus==sourceGUID) then
				LockNotes_ChangeMainFrame(""..spellName.." down.", 0.72, 0.53, 0.04, spellID);
			elseif (not targetAndFocusOnly) then
				LockNotes_ChangeMainFrame(""..spellName.." down.", 0, 1, 0, spellID);
			end
        elseif (spellID == 23920) then
			if (sourceGUID==target or sourceGUID==focus or (not targetAndFocusOnly)) then
				if (not MySpellReflected) then
					LockNotes_ChangeMainFrame(""..spellName.." down.", 0, 1, 0, spellID);
				end
            end
		end
    end
   
------------------------------------------------------------- Dispel ----------------------------------------
elseif(eventType=="SPELL_DISPEL" or eventType=="SPELL_STOLEN" or eventType=="SPELL_DISPEL_FAILED") then
    local petGUID = UnitGUID("pet");
	local selfGUID = UnitGUID("player");
    if(sourceGUID==petGUID or sourceGUID==selfGUID) then
		local spellLink = GetSpellLink(arg12);
		local chatMessage = ("Dispelled "..LockNotes_StripServer(destName).." ("..spellLink..")");
		if(eventType=="SPELL_DISPEL_FAILED") then
			chatMessage = ("Dispel Failed");
		end
        if(LNDispelTable["DispelChatlog"]) then
			local spellTexture = GetSpellTexture(arg12);
			local spellTextureString = string.format("|T%s:0:0|t", spellTexture)
			print(chatMessage.." "..spellTextureString);
        end
        if(LNDispelTable["DispelSay"]) then
            SendChatMessage(chatMessage,"say");
        end
        if(LNDispelTable["DispelParty"] and GetNumSubgroupMembers() > 0) then
            SendChatMessage(chatMessage,"party");
        end
        if(LNDispelTable["DispelRaid"] and GetNumGroupMembers() > 0 and IsInRaid()) then
            SendChatMessage(chatMessage,"raid");
        end
        if(LNDispelTable["DispelBattleground"] and UnitInBattleground("player")) then
            SendChatMessage(chatMessage,"battleground");
        end
        if(LNDispelTable["DispelVisualAlert"]) then
            if  bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then
                LockNotes_DispelSpellLockFrameFontString:SetTextColor(1, 1, 0); -- yellow
            else
                LockNotes_DispelSpellLockFrameFontString:SetTextColor(1, 1, 0); -- white
            end
            LockNotes_DispelSpellLockFrameFlasher:Stop();
            LockNotes_DispelSpellLockFrameFontString:SetText(chatMessage);
            LockNotes_DispelSpellLockFrameTexture:SetTexture(GetSpellTexture(arg12));
            LockNotes_DispelSpellLockFrameFlasher:Play();
        end
    end
------------------------------------------------------------ Interrupt --------------------------------------
elseif(eventType=="SPELL_INTERRUPT") then
    local petGUID = UnitGUID("pet");
	local selfGUID = UnitGUID("player");
    if(sourceGUID==petGUID or sourceGUID==selfGUID) then
		local spellLink = GetSpellLink(arg12);
		local chatMessage = ("Interrupted "..LockNotes_StripServer(destName).." ("..spellLink..")");
        if(LNSpelllockTable["SpelllockChatlog"]) then
			local spellTexture = GetSpellTexture(arg12);
			local spellTextureString = string.format("|T%s:0:0|t", spellTexture)
			print(chatMessage.." "..spellTextureString);
        end
        if(LNSpelllockTable["SpelllockSay"]) then
            SendChatMessage(chatMessage,"say");
        end
        if(LNSpelllockTable["SpelllockParty"] and GetNumSubgroupMembers() > 0) then
            SendChatMessage(chatMessage,"party");
        end
        if(LNSpelllockTable["SpelllockRaid"] and GetNumGroupMembers() > 0 and IsInRaid()) then
            SendChatMessage(chatMessage,"raid");
        end
        if(LNSpelllockTable["SpelllockBattleground"] and UnitInBattleground("player")) then
            SendChatMessage(chatMessage,"battleground");
        end
        if(LNSpelllockTable["SpelllockVisualAlert"]) then
			LockNotes_DispelSpellLockFrameFlasher:Stop();
			LockNotes_DispelSpellLockFrameFontString:SetText(chatMessage);
            LockNotes_DispelSpellLockFrameFontString:SetTextColor(0, 1, 0);
            LockNotes_DispelSpellLockFrameTexture:SetTexture(GetSpellTexture(arg12));
            LockNotes_DispelSpellLockFrameFlasher:Play();
        end                
    end
------------------------------------------------------------- Resists ---------------------------------------
elseif (eventType == "SPELL_MISSED") then -- need to add: evade, deflect (what is this?), check what happens when debuff is on an evading mob, dont want spam for each dot tick, even tho most evades remove all debuffs on them, not all
	if bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then -- Makes sure it's my own spell or my pet's spell
		local petGUID = UnitGUID("pet");
		if (sourceGUID==petGUID and select(1,GetSpellAutocast(spellID)) or ignoreMissSpells[spellID]) then
			return
		end
		local ResistMethod = nil;
		if (destName == "Grounding Totem") or (destName == "Тотем заземления") then
		    ResistMethod = "Grounded"
		elseif (arg12 == "REFLECT") then
		    ResistMethod = "reflected"
		    MySpellReflected = true;
		elseif (arg12 == "IMMUNE") then
    		ResistMethod = "failed (IMMUNE)"
        elseif (arg12 == "DEFLECT") then
            ResistMethod = "deflected"
		elseif (arg12 == "MISS") then
			ResistMethod = "missed"
    	elseif (arg12 == "RESIST") then
	    	ResistMethod = "resisted"
    	end
	    if (ResistMethod) then
			local spellLink = GetSpellLink(spellID);
		    LockNotes_FearSeduceFrameFlasher:Stop()
			if (LockNotes_Icons) then
				local spellTexture = GetSpellTexture(spellID);
				local spellTextureString = string.format("|T%s:0:0|t", spellTexture)
				LockNotes_FearSeduceFrameFontString:SetText(""..spellName.." "..ResistMethod..".  "..spellTextureString);
			else
				LockNotes_FearSeduceFrameFontString:SetText(""..spellName.." "..ResistMethod..".");
			end
            if(ResistMethod == "Grounded") then
                LockNotes_FearSeduceFrameFontString:SetTextColor(.55, .27, .07);
            else
				LockNotes_FearSeduceFrameFontString:SetTextColor(1, 1, 1);
            end
            LockNotes_FearSeduceFrameFlasher:Play();
		    if (ResistMethod ~= "failed (IMMUNE)" and ResistMethod ~= "deflected") then -- only play sound file when you need to instantly recast what you just casted
			   	PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\cling.ogg");
			end
		end
    end
---------------------------------------------------Unit Dies--------------------------------------
elseif (eventType == "UNIT_DIED") then
    if (bit.band(destFlags, COMBATLOG_OBJECT_CONTROL_PLAYER) > 0) then
        if(destGUID==UnitGUID("target")) then
			LockNotes_ChangeMainFrame("TARGET IS DEAD!", 0, 1, 0, 14148);
            if(LockNotes_DeathAnnounceSounds)then
                PlaySoundFile("Sound\\Character\\PlayerExertions\\NightElfMaleFinal\\NightElfMaleMainDeath.ogg");
            end
        elseif(destGUID==UnitGUID("focus")) then
			LockNotes_ChangeMainFrame("FOCUS IS DEAD!", 1, 0, 1, 14148);
            if(LockNotes_DeathAnnounceSounds) then
                PlaySoundFile("Sound\\Character\\PlayerExertions\\GnomeMaleFinal\\GnomeMaleMainWoundCrit.ogg");
            end
        end
	end
-------------------------------------------Tremor Totem-----------------------------
elseif (eventType == "SPELL_SUMMON") then
    if (LockNotes_TremorTotem and destName == "Tremor Totem" and (bit.band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0)) then
        LockNotes_TremorTotemID = destGUID;
		LockNotes_TremorTotemFrameFlasher:Stop();
		if (LockNotes_Icons) then
			LockNotes_TremorTotemFontString:SetText("Tremor Totem Up! |TInterface\\Icons\\spell_nature_tremortotem:0:0|t");
		else
			LockNotes_TremorTotemFontString:SetText("Tremor Totem Up!");
		end
        LockNotes_TremorTotemFrameFlasher:Play()
        PlaySoundFile("Interface\\AddOns\\LockNotes\\Sounds\\tremornoise.ogg");
    end
    
elseif (eventType == "UNIT_DESTROYED" and destGUID == LockNotes_TremorTotemID) then
    LockNotes_TremorTotemFrameFlasher:Stop();
end
------------------------------------------------------------------------------------------------------------------------------------------
end